<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 22/09/2015
 * Time: 10:45
 */

namespace Service;

use Util\DateUtil;
use Zeedhi\Framework\HTTP\Request;

class LogService {

    /**
     * Verificar possibilidade de criação de log de acessos ao servidor.
     * Criado inicialmente para testes.
     */

    const DSDIRLOG = '..\..\..\..\log';

    public function saveRequestRowData(Request $httpRequest)
    {
        $dsDirArqLog = __DIR__.self::DSDIRLOG;

        $date = new \DateTime();

        if (!is_dir($dsDirArqLog)) {
            mkdir($dsDirArqLog);
        }

        $log = fopen($dsDirArqLog.'\ApiHcmServicesLog_'.$date->format('Y_m_d').'.txt','a+');

        fwrite($log, '----------------------------'."\n");
        fwrite($log, $date->format('d/m/Y H:i:s')."\n");
        fwrite($log, '----------------------------'."\n");
        fwrite($log, 'Method: '.$httpRequest->getMethod()."\n");
        fwrite($log, 'UserId: '.$httpRequest->getUserId()."\n");
        fwrite($log, 'URI: '.$httpRequest->getRequestUri()."\n");
        fwrite($log, 'Content: '.$httpRequest->getContent()."\n");
        fwrite($log, 'ContentType: '.$httpRequest->getContentType()."\n");
        fwrite($log, 'Header: '.json_encode($httpRequest->getHeaders()->all())."\n");
        if (isset($_SERVER['REMOTE_ADDR'])) {
            fwrite($log, 'IP Request: '.$_SERVER['REMOTE_ADDR']."\n");
        }
        fwrite($log, "\n");

        fclose($log);
    }

    public function saveData($data)
    {
        $dsDirArqLog = __DIR__.self::DSDIRLOG;

        $date = new \DateTime();

        if (!is_dir($dsDirArqLog)) {
            mkdir($dsDirArqLog);
        }

        $log = fopen($dsDirArqLog.'\ApiHcmServicesLog_'.$date->format('Y_m_d').'.txt','a+');

        fwrite($log, '----------------------------'."\n");
        fwrite($log, $date->format('d/m/Y H:i:s')."\n");
        fwrite($log, '----------------------------'."\n");
        fwrite($log, 'Data: '.json_encode($data)."\n");
        if (isset($_SERVER['REMOTE_ADDR'])) {
            fwrite($log, 'IP Request: '.$_SERVER['REMOTE_ADDR']."\n");
        }
        fwrite($log, "\n");

        fclose($log);
    }

}