/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CONFTELA                                                 */
/* Tabela : CONFTELA                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 10/01/2005 - Wanderson Alosio                                             */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CONFTELA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CONFTELA
GO

CREATE TRIGGER DTULTATU_CONFTELA
ON CONFTELA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONFTELA', CDFILIAL, 'CDFILIAL='+ CDFILIAL+';'+'NRCONFTELA='+NRCONFTELA+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONFTELA
      SET DTULTATUCFTE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(CONFTELA.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(CONFTELA.NRCONFTELA,0) = ISNULL(INSERTED.NRCONFTELA,0));
   END;
END;
GO


UPDATE CONFTELA SET DTULTATUCFTE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUCFTE IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUCFTE' and
            type = 'D')
   ALTER TABLE CONFTELA DROP CONSTRAINT DEFAULT_DTULTATUCFTE
GO

ALTER TABLE CONFTELA ADD CONSTRAINT DEFAULT_DTULTATUCFTE
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUCFTE
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CONFTELA','4.11.194';
GO

